#include "DemoSelectorView.h"
#include "../../../../pokktsdk/PokktCocosManager.h"
#include "../Storage.h"

using namespace cocos2d;
using namespace ui;

bool DemoSelectorView::init()
{
    if (!BaseView::init())
        return false;
    
    backButton->setVisible(false);
    
    int yPos = logo->getPosition().y - logo->getBoundingBox().size.height / 2 - 100;
    
    // create buttons
    
    _btnDemoWithAutoCaching = createButton("Demo With Auto Caching", CC_CALLBACK_1(DemoSelectorView::handleDemoWithAutoCaching, this), "button_purple.png");
    _btnDemoWithAutoCaching->setPosition(Vec2(visibleSize.width / 2, yPos));
    this->addChild(_btnDemoWithAutoCaching);
    
    yPos -= 150;
    
    _btnDemoSansAutoCaching = createButton("Demo Sans Auto Caching", CC_CALLBACK_1(DemoSelectorView::handleDemoSansAutoCaching, this));
    _btnDemoSansAutoCaching->setPosition(Vec2(visibleSize.width / 2, yPos));
    this->addChild(_btnDemoSansAutoCaching);
    
    // misc. pokkt flag setup
    PokktCocosManager::setDebug(true);
    PokktCocosManager::showLog("pokkt init...");
    //PokktCocosManager::getInstance()->showToast("pokkt init...");
    
    return true;
}

void DemoSelectorView::handleBackPress(cocos2d::Ref *pSender)
{
    // exit the app
    Director::getInstance()->end();
}

void DemoSelectorView::initPokkt(bool autoCaching)
{
    PokktCocosConfig *pokktConfig = new PokktCocosConfig();
    
    // SET THESE UP AS PER VALUES PROVIDED TO YOU
    
    // SampleApp(videodemo) credentials
    pokktConfig->setSecurityKey("iJ02lJss0M");
    pokktConfig->setApplicationId("a2717a45b835b5e9f50284a38d62a74e");
    
    // additional configurations
    pokktConfig->setIntegrationType(PokktCocosConfig::INTEGRATION_TYPE_ALL);
    pokktConfig->setThirdPartyUserId("123456");
    pokktConfig->setAutoCacheVideo(autoCaching);
    pokktConfig->setRetryDuration(30);
    Storage::setAutoCaching(autoCaching);
    
    // init pokkt
    PokktCocosManager::initPokkt();
}

void DemoSelectorView::handleDemoWithAutoCaching(cocos2d::Ref *pSender)
{
    initPokkt(true);
    
    changeView(AppView::MainView);
}

void DemoSelectorView::handleDemoSansAutoCaching(cocos2d::Ref *pSender)
{
    initPokkt(false);
    
    changeView(AppView::MainView);
}
