#ifndef __CocosPokktApp__VideoView__
#define __CocosPokktApp__VideoView__

#include <stdio.h>
#include "BaseView.h"
#include "cocos2d.h"
#include "../../../../../cocos2d/cocos/ui/UIButton.h"
#include "../../../../../cocos2d/cocos/ui/UIText.h"
#include "../../../../pokktsdk/PokktCocosConfig.h"

class VideoView : public BaseView
{
public:
    
    CREATE_FUNC(VideoView);
    
    virtual ~VideoView();
    
    virtual void handleBackPress(cocos2d::Ref* pSender);
    
protected:
    
    virtual bool init();
    
private:
    
    static PokktCocosConfig *pokktCocosConfig;
    
    cocos2d::ui::Button* _btnStartCaching;
    cocos2d::ui::Button* _btnPlayVideo;
    cocos2d::ui::Button* _btnPlayVideoNonIncent;
    cocos2d::ui::Button* _btnExportLog;
    
    cocos2d::ui::Text* _txtPointsEarned;
    cocos2d::ui::Text* _txtCacheMessage;
    
    int _coinsEarned;
    
    // handlers
    void handleStartCaching(cocos2d::Ref* pSender);
    void handlePlayVideo(cocos2d::Ref* pSender);
    void handlePlayVideoNonIncent(cocos2d::Ref* pSender);
    void handleExportLog(cocos2d::Ref* pSender);
    
    // pokkt handlers
    void handleVideoClosed(std::string message);
    void handleVideoDisplayed(std::string message);
    void handleVideoSkipped(std::string message);
    void handleVideoCompleted(std::string message);
    void handleVideoGratified(std::string coins);
    void handleDownloadCompleted(std::string coinsToEarn);
    void handleDownloadFailed(std::string message);
};

#endif /* defined(__CocosPokktApp__VideoView__) */
