//
//  PokktCocosConfig.h
//  Cocos2dxV2xPlugin
//
//  Created by SWARAJ on 16/06/15.
//
//

#ifndef __CocosPokktApp__PokktCocosConfig__
#define __CocosPokktApp__PokktCocosConfig__

#include <stdio.h>
#include "PokktNativeExtension.h"

class PokktCocosConfig
{
    friend class PokktNativeExtension;
    
public:
    typedef enum __pokktIntegrationType
    {
        // common methods
        INTEGRATION_TYPE_ALL,
        INTEGRATION_TYPE_OFFERWALL,
        INTEGRATION_TYPE_VIDEO
    } PokktIntegrationType;
    
private:
    
    // essential
    std::string securityKey;
    std::string applicationId;
    PokktIntegrationType integrationType;
    bool autoCacheVideo;
    std::string thirdPartyUserId;
    
    // offer wall specific
    std::string offerWallAssetValue;
    bool closeOnSuccessFlag;
    
    // video campaign specific
    bool skipEnabled;
    int defaultSkipTime;
    std::string customSkipMessage;
    std::string screenName;
    bool incentivised;
    bool backButtonDisabled;
    int retryDuration;
    
    // optional
    std::string name;
    std::string age;
    std::string sex;
    std::string mobileNo;
    std::string emailAddress;
    std::string location;
    std::string birthday;
    std::string maritalStatus;
    std::string facebookId;
    std::string twitterHandle;
    std::string education;
    std::string nationality;
    std::string employment;
    std::string maturityRating;
    
    // analytics
    std::string googleAnalyticsID;
    std::string mixPanelProjectToken;
    std::string flurryApplicationKey;
    std::string selectedAnalyticsType;
    
public:
    
    // constructor
    PokktCocosConfig();
    
    // common methods
    void setSecurityKey(std::string securityKey);
    std::string getSecurityKey();
    void setApplicationId(std::string applicationId);
    std::string getApplicationId();
    void setIntegrationType(PokktIntegrationType integrationType);
    PokktIntegrationType getIntegrationType();
    void setAutoCacheVideo(bool autoCacheVideo);
    bool getAutoCacheVideo();
    void setThirdPartyUserId(std::string thirdPartyUserId);
    std::string getThirdPartyUserId();
    
    // offerwall methods
    void setOfferWallAssetValue(std::string offerWallAssetValue);
    std::string getOfferWallAssetValue();
    void setCloseOnSuccessFlag(bool closeOnSuccessFlag);
    bool getCloseOnSuccessFlag();
    
    // video methods
    void setSkipEnabled(bool skipEnabled);
    bool getSkipEnabled();
    void setDefaultSkipTime(int defaultSkipTime);
    int getDefaultSkipTime();
    void setCustomSkipMessage(std::string customSkipMessage);
    std::string getCustomSkipMessage();
    void setScreenName(std::string screenName);
    std::string getScreenName();
    void setIncentivised(bool incentivised);
    bool getIncentivised();
    void setBackButtonDisabled(bool backButtonDisabled);
    bool getBackButtonDisabled();
    void setRetryDuration(int retryDuration);
    int getRetryDuration();
    
    // optional methods
    void setName(std::string name);
    std::string getName();
    void setAge(std::string age);
    std::string getAge();
    void setSex(std::string sex);
    std::string getSex();
    void setMobileNo(std::string mobileNo);
    std::string getMobileNo();
    void setEmailAddress(std::string emailAddress);
    std::string getEmailAddress();
    void setLocation(std::string location);
    std::string getLocation();
    void setBirthday(std::string birthday);
    std::string getBirthday();
    void setMaritalStatus(std::string maritalStatus);
    std::string getMaritalStatus();
    void setFacebookId(std::string facebookId);
    std::string getFacebookId();
    void setTwitterHandle(std::string twitterHandle);
    std::string getTwitterHandle();
    void setEducation(std::string education);
    std::string getEducation();
    void setNationality(std::string nationality);
    std::string getNationality();
    void setEmployment(std::string employment);
    std::string getEmployment();
    void setMaturityRating(std::string maturityRating);
    std::string getMaturityRating();
    
    // analytics methods
    void setGoogleAnalyticsID(std::string name);
    std::string getGoogleAnalyticsID();
    void setMixPanelProjectToken(std::string name);
    std::string getMixPanelProjectToken();
    void setFlurryApplicationKey(std::string name);
    std::string getFlurryApplicationKey();
    void setSelectedAnalyticsType(std::string name);
    std::string getSelectedAnalyticsType();
};


#endif /* defined(__CocosPokktApp__PokktCocosConfig__) */
