//
//  PokktNetworkInterface.h
//  PokktSDK
//
//  Created by Subhendu Sekhar Sahu on 12/10/15.
//  Copyright © 2015 Pokkt. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "PokktConfig.h"
#import "NetworkModel.h"

@interface PokktNetworkDelegate : NSObject

+ (void) didFinishedVideoDownload: (PokktConfig *)pokktConfig networkModel: (NetworkModel *)networkModel
                      rewardValue: (float)reward downLoadTime: (NSString *)downloadTime;

+ (void) didFailedVideoDownload:(PokktConfig *)pokktConfig networkModel:(NetworkModel *)networkModel
                   errorMessage:(NSString *)errorMsg;

+ (void) onVideoCompleted: (PokktConfig *)pokktConfig networkModel: (NetworkModel *)networkModel;

+ (void) onVideoDisplayed: (PokktConfig *)pokktConfig networkModel: (NetworkModel *)networkModel;

+ (void) onVideoGratified: (PokktConfig *)pokktConfig networkModel: (NetworkModel *)networkModel rewardPoint: (float)reward;

+ (void) onVideoSkipped: (PokktConfig *)pokktConfig networkModel: (NetworkModel *)networkModel;

+ (void) onVideoClosed: (PokktConfig *)pokktConfig networkModel: (NetworkModel *)networkModel;

@end